#!/bin/bash
# vim: ai ts=2 sw=2 et sts=2 ft=sh

PWD="/home/easybuild/git/it4i-modules"
cd $PWD || exit 1

STATE=$(git fetch 2>&1 | grep master)
if [ ! -z "$STATE" ]; then
  git pull
  ./get_modules.sh
  exit 0
fi

CLUSTER="$CLUSTERNAME"
if [ -z "$CLUSTER" ]; then
   echo "CLUSTERNAME not defined"
   exit 1
fi

if [ "$CLUSTER" == "DGX" ]; then
   ml --show-hidden -t av 2>&1 | awk '{print $1 ",4"}' | grep -v -e '/,\|:' | sort -u > dgx.csv
  ./modules.py > dgx.md
elif [ "$CLUSTER" == "BARBORA" ]; then
   ml --show-hidden -t av 2>&1 | awk '{print $1 ",2"}' | grep -v -e '/,\|:' | sort -u > barbora.csv
   python2  ./modules.py > barbora.md
elif [ "$CLUSTER" == "KAROLINA" ]; then
   ml --show-hidden -t av 2>&1 | awk '{print $1 ",1"}' | grep -v -e '/,\|:' | sort -u > karolina.csv
     ./modules.py | sed "s|(N/A)|()|g" > karolina.md
fi

DATE=$(date -R)
git diff --exit-code || git commit -am "$DATE"
git push origin master

git log --since=2023-08-01 -p -- karolina.csv | grep "^+\|^-\|Date" | grep -v "@\|karolina" | sed 's|^+|   * add |g' | sed 's|^-|   * remove |g' | sed 's|Date:   |\n## |g' | sed 's|+0200|\n|g' > karolina-changelog.md
git log --since=2023-08-01 -p -- barbora.csv | grep "^+\|^-\|Date" | grep -v "@\|barbora" | sed 's|^+|   * add |g' | sed 's|^-|   * remove |g' | sed 's|Date:   |\n## |g' | sed 's|+0200|\n|g' > barbora-changelog.md
git log --since=2023-08-01 -p -- dgx.csv | grep "^+\|^-\|Date" | grep -v "@\|dgx" | sed 's|^+|   * add |g' | sed 's|^-|   * remove |g' | sed 's|Date:   |\n## |g' | sed 's|+0200|\n|g' > dgx-changelog.md

git add karolina-changelog.md barbora-changelog.md dgx-changelog.md
git commit -am "$DATE Changelog"
git push origin master
